"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = require("commander");
const profile_1 = require("../profile");
const open_1 = __importDefault(require("open"));
const http = __importStar(require("http"));
const axios_1 = __importDefault(require("axios"));
commander_1.program.command('login [profile]')
    .description('Run the auth flow and display the resulting token')
    .action(async (profileName) => {
    const profile = await (0, profile_1.loadProfile)(profileName);
    const config = await (0, profile_1.getOpenIdConfiguration)(profile);
    const port = profile.callbackPort ?? 8000;
    const host = profile.callbackHost ?? 'localhost';
    const protocol = profile.callbackHttps ? 'https' : 'http';
    const redirectUri = `${protocol}://${host}:${port}${profile.callbackPath}`;
    const url = new URL(config.authorization_endpoint);
    url.searchParams.append('client_id', profile.clientId);
    url.searchParams.append('redirect_uri', redirectUri);
    url.searchParams.append('scope', profile.scopes.join(' '));
    url.searchParams.append('response_type', 'code');
    const runningServer = new Promise((resolve, reject) => {
        let server;
        const requestListener = async (req, res) => {
            const [path, params] = req.url.split('?');
            if (path !== profile.callbackPath ?? '/') {
                console.info(`Unknown path: ${path}`);
                res.writeHead(404).end();
                return;
            }
            const queryParams = new URLSearchParams(params);
            const code = queryParams.get('code');
            if (!code) {
                throw new Error(`Didn't get code: ${req.url}`);
            }
            const data = {
                grant_type: 'authorization_code',
                client_id: profile.clientId,
                client_secret: profile.clientSecret,
                code,
                redirect_uri: redirectUri,
            };
            const tokenResponse = await axios_1.default.request({
                url: config.token_endpoint,
                method: 'POST',
                headers: { 'content-type': 'application/x-www-form-urlencoded' },
                data: new URLSearchParams(data).toString(),
                validateStatus: () => true,
            });
            console.info(tokenResponse.data);
            const createTokenSection = (title, token) => token ? `
        <h3>${title}</h3>
        <a href="https://jwt.io/?token=${token}">View</a> | <a onClick="javascript:copyToken('${title}', '${token}');" >Copy</a>
        <p>${token}</p>` : '';
            res.writeHead(200, undefined, {
                'content-type': 'application/html',
            });
            res.end(`<html>
  <head>
    <script>
        function copyToken(title, token) {
          navigator.clipboard.writeText(token);
          alert("Copied the " + title);
        }
    </script>
  </head>
    <body>
        ${createTokenSection('Access Token', tokenResponse.data.access_token)}
        ${createTokenSection('ID Token', tokenResponse.data.id_token)}
    </body>
</html>`);
            server?.close((err) => {
                if (err) {
                    reject(err);
                }
                else {
                    resolve(true);
                }
            });
            process.exit(0);
        };
        server = http.createServer(requestListener);
        server.listen(port, host, () => {
            console.info(`Listening on http://${host}:${port}`);
        });
    });
    const loginUrl = url.toString();
    console.info(`Opening ${loginUrl}`);
    await (0, open_1.default)(loginUrl);
    await runningServer;
});
