"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildProfile = void 0;
const inquirer_1 = __importDefault(require("inquirer"));
async function buildProfile({ baseProfile, config, baseUrl }) {
    return inquirer_1.default.prompt([
        {
            type: 'text',
            name: 'baseUrl',
            message: 'What is the base url?',
            default: baseProfile?.baseUrl,
        },
        {
            type: 'text',
            name: 'clientId',
            message: 'What is the client id?',
            default: baseProfile?.clientId,
        },
        {
            type: 'password',
            name: 'clientSecret',
            message: 'What is the client secret?',
            default: baseProfile?.clientSecret,
        },
        {
            type: 'input',
            name: 'callbackHost',
            message: 'What host should be used for callbacks?',
            default: baseProfile?.callbackHost ?? 'localhost',
        },
        {
            type: 'number',
            name: 'callbackPort',
            message: 'What port are callbacks sent to?',
            default: baseProfile?.callbackPort ?? 8000,
        },
        {
            type: 'confirm',
            name: 'callbackHttps',
            message: 'Should HTTPS be used for callbacks?',
            default: baseProfile?.callbackHttps ?? false,
        },
        {
            type: 'input',
            name: 'callbackPath',
            message: 'What server path should callbacks be sent to?',
            default: baseProfile?.callbackPath ?? '/success',
        },
        {
            type: 'checkbox',
            name: 'scopes',
            message: 'What scopes should be requested?',
            choices: config.scopes_supported,
            default: baseProfile?.scopes,
        },
    ], { baseUrl });
}
exports.buildProfile = buildProfile;
